package cn.estsh.i3plus.pojo.bsp.common;

import groovy.lang.GroovyClassLoader;
import groovy.lang.GroovyObject;

import java.util.Map;

/**
 * @Description :脚本执行工具类
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2021/7/22 15:38
 * @Modify:
 **/
public class GroovyCommonUtil {

    public static Map<String, Object> executeGroovy(String script, String methodName, Object... args) throws IllegalAccessException, InstantiationException {
        Class scriptClass = new GroovyClassLoader().parseClass(script);
        GroovyObject groovyObject = (GroovyObject) scriptClass.newInstance();
        Map<String, Object> resultMap;
        if (args.length > 0) {
            resultMap = (Map) groovyObject.invokeMethod(methodName, args);
        } else {
            resultMap = (Map) groovyObject.invokeMethod(methodName, null);
        }

        return resultMap;
    }
}
