package cn.estsh.i3plus.pojo.bsp.common.script.strategy;

import groovy.lang.GroovyClassLoader;
import groovy.lang.GroovyObject;

import java.util.Map;
import java.util.Set;

/**
 * @Description : 默认执行execute方法，execute入参为空，groovy的属性是execute的入参
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2022/1/26 15:03
 * @Modify:
 **/
public class GroovyScript implements Script{

    @Override
    public Map<String, Object> execute(String script,Map<String, Object> paramMap,String methodName) throws IllegalAccessException, InstantiationException {
        Class scriptClass = new GroovyClassLoader().parseClass(script);
        GroovyObject groovyObject = (GroovyObject) scriptClass.newInstance();
        Set<String> keys = paramMap.keySet();
        keys.forEach(key ->{
            groovyObject.setProperty(key,paramMap.get(key));
        });
        methodName = methodName != null ? methodName : "execute";
        Map<String, Object> resultMap = (Map<String, Object>)groovyObject.invokeMethod(methodName,null);
        return resultMap;
    }
}
